//--------------------------------------------------------------
// File     : com.h
//--------------------------------------------------------------

//--------------------------------------------------------------
#ifndef __STM32F4_UB_COM_H
#define __STM32F4_UB_COM_H


//--------------------------------------------------------------
// Includes
//--------------------------------------------------------------
#include "stm32f4xx.h"
#include "stm32_ub_usb_cdc.h"
#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#include "dds.h"


//--------------------------------------------------------------
#define   COM_END_BYTE    LFCR  // Endekennung beim senden


//--------------------------------------------------------------
// RX-Puffer
//--------------------------------------------------------------
#define  COM_RX_BUF_LEN    50  // laenge in bytes
#define  COM_TX_BUF_LEN    50  // laenge in bytes
char com_rx_buf[COM_RX_BUF_LEN];
char com_tx_buf[COM_TX_BUF_LEN];



//--------------------------------------------------------------
typedef enum {
  COM_CHANGE_NONE =0,  // keine Aenderung
  COM_CHANGE_FRQ,      // FRQ-Wert aendern
  COM_CHANGE_AMP,      // Amplituden-Wert aendern
  COM_CHANGE_OFF,      // Offset-Wert aendern
  COM_CHANGE_WAVE      // Kurvenform aendern
}COM_CHANGE_t;


//--------------------------------------------------------------
typedef enum {
  COM_USER_WAIT =0,    // warte auf START
  COM_USER_DATA,       // Daten
  COM_USER_VERIFY      // Verify
}COM_USER_t;



//--------------------------------------------------------------
// Struktur vom "COM"
//--------------------------------------------------------------
typedef struct {
  COM_USER_t user_mode;  // Mode der User-Kurvenform
  uint32_t user_ptr;     // Pointer
  uint32_t user_error;   // Error Nr
}COM_t;
COM_t COM;



//--------------------------------------------------------------
// Globale Funktionen
//--------------------------------------------------------------
void com_init(void);
COM_CHANGE_t com_do(void);



//--------------------------------------------------------------
#endif // __STM32F4_UB_COM_H
